################################################################################################
#
# Walking Chests
#
################################################################################################


################################################################# General ################################################################

scoreboard objectives add r dummy
scoreboard objectives add ET dummy
scoreboard objectives add ET2 dummy
scoreboard objectives add rc minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add sneak minecraft.custom:minecraft.sneak_time
scoreboard objectives add talk minecraft.custom:minecraft.talked_to_villager
scoreboard objectives add walk minecraft.custom:minecraft.walk_one_cm
scoreboard objectives add sprint minecraft.custom:minecraft.sprint_one_cm
scoreboard objectives add crouch minecraft.custom:minecraft.crouch_one_cm
scoreboard objectives add jump minecraft.custom:minecraft.jump
scoreboard objectives add pick_used minecraft.used:minecraft.diamond_pickaxe
scoreboard objectives add x dummy
scoreboard objectives add y dummy
scoreboard objectives add z dummy
scoreboard objectives add dx dummy
scoreboard objectives add dz dummy
scoreboard objectives add dy dummy
scoreboard objectives add walk_timer dummy
scoreboard objectives add chest_is_walking dummy
scoreboard objectives add angry dummy
scoreboard objectives add intro_timer dummy
scoreboard objectives add talk_cd dummy
scoreboard objectives add talk_count dummy
scoreboard objectives add ex_timer dummy
scoreboard objectives add chest_health dummy
scoreboard objectives add bite_timer dummy
scoreboard objectives add bite_timer2 dummy
scoreboard objectives add switch_timer dummy
scoreboard objectives add walk_block dummy
scoreboard objectives add r dummy



tellraw @a[tag=!init_msg] ["",{"text":"\n\n\n==-=-- Walking Chest - ","color":"red","bold":true},{"text":"by McMakistein","color":"gold","bold":true},{"text":" --=-==","color":"red","bold":true},{"text":"\n                 [","color":"none","bold":false},{"text":"Explanation video about this creation","color":"dark_green","clickEvent":{"action":"open_url","value":"https://www.youtube.com/watch?v=nEH1_GPZB4U"}},{"text":"]\n\n","color":"none"},{"text":"                       More of my work:\n","bold":true,"color":"none"},{"text":"                [","bold":false,"color":"none"},{"text":"Youtube","color":"red","bold":true,"clickEvent":{"action":"open_url","value":"https://www.youtube.com/user/McMakistein?sub_confirmation=1."},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Subscribe for more commandblock creation like this!"}]}}},{"text":"] - [","color":"none","bold":false},{"text":"Twitter","color":"blue","bold":true,"clickEvent":{"action":"open_url","value":"https://twitter.com/MrMakistein"},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Follow me on twitter for updates and sneakpeaks on new projects!"}]}}},{"text":"] - [","color":"none","bold":false},{"text":"Instagram","color":"gold","bold":true,"clickEvent":{"action":"open_url","value":"http://instagram.com/mrmakistein"},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Follow me on Instagram if you want to know more about me as a person!"}]}}},{"text":"]","color":"none","bold":false}]
tag @a add init_msg

gamerule logAdminCommands false
gamerule commandBlockOutput false

scoreboard players set @e ET 1
scoreboard players set @e[type=item] ET 0
scoreboard players set @e[type=armor_stand] ET 0
scoreboard players set @e[type=end_crystal] ET 0
scoreboard players set @e[type=area_effect_cloud] ET 0
scoreboard players set @e[type=boat] ET 0
scoreboard players set @e[type=arrow] ET 0
scoreboard players set @e[type=painting] ET 0
scoreboard players set @e[type=player] ET 0
scoreboard players set @e[type=arrow] ET 0
scoreboard players set @e[type=minecart] ET 0
scoreboard players set @e[type=experience_orb] ET 0
scoreboard players set @e[type=zombie] ET 2
scoreboard players set @e[type=zombie_villager] ET 2
scoreboard players set @e[type=zombie_horse] ET 2
scoreboard players set @e[type=zombie_pigman] ET 2
scoreboard players set @e[type=wither_skeleton] ET 2
scoreboard players set @e[type=husk] ET 2
scoreboard players set @e[type=skeleton] ET 2
scoreboard players set @e[type=stray] ET 2
scoreboard players set @e[tag=chest_seat] ET 0


################################################### Give #############################################

give @a[tag=give] minecraft:ghast_spawn_egg{display:{Name:"{\"text\":\"Walking Chest\",\"italic\":\"false\"}",Lore:["Rightclick to spawn."]},EntityTag:{id:"minecraft:armor_stand",Invisible:1,Marker:1,Tags:["sp1","sp"]},HideFlags:63}
tag @a remove give

execute as @e[type=item,nbt={OnGround:1b,Item:{id:"minecraft:chest",Count:1b}}] at @s run execute as @e[type=item,nbt={OnGround:1b,Item:{id:"minecraft:nether_star",Count:1b}},distance=..1] at @s run summon area_effect_cloud ~ ~ ~ {Tags:["spp","spp1"]}

execute as @e[tag=spp1] at @s run kill @e[type=item,nbt={OnGround:1b,Item:{id:"minecraft:nether_star",Count:1b}},limit=1,sort=nearest]
execute as @e[tag=spp1] at @s run kill @e[type=item,nbt={OnGround:1b,Item:{id:"minecraft:chest",Count:1b}},limit=1,sort=nearest]
execute as @e[tag=spp] at @s run particle minecraft:enchant ~ ~0.25 ~ 0.2 0.2 0.2 0.5 20
execute as @e[tag=spp] at @s run particle minecraft:large_smoke ~ ~0.25 ~ 0.1 0.1 0.1 0.03 3
execute as @e[tag=spp] at @s run playsound minecraft:block.fire.extinguish master @a

execute as @e[tag=spp1] at @s run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:husk_spawn_egg",Count:1b,tag:{display:{Name:'{"text":"Walking Chest","italic":false}'},EntityTag:{id:"minecraft:armor_stand",Invisible:1,Marker:1,Tags:["sp1","sp"]}}}}


############################################################ Spawn #####################################################

execute as @e[tag=sp1] at @s run summon armor_stand ~ ~ ~ {Tags:["chest_as","chest_as_old"],NoGravity:1,Invisible:1,Marker:1,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:24},Count:1}],DisabledSlots:4144959}
execute as @e[tag=sp1] at @s run summon villager ~ ~ ~ {Tags:[chest_villager],Silent:1,PersistenceRequired:1,ActiveEffects:[{Id:14b,Amplifier:1b,Duration:99999999,ShowParticles:0b}],NoAI:1}
kill @e[tag=sp1]

effect give @e[tag=chest_villager] invisibility 9 9 true


scoreboard players add @e[tag=chest_as] intro_timer 0
scoreboard players add @e[tag=chest_as,scores={intro_timer=1..20}] intro_timer 1
scoreboard players set @e[tag=chest_as,scores={intro_timer=21}] intro_timer 40

execute as @e[tag=chest_as,scores={intro_timer=2}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:23},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=3}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:22},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=4}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:21},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=5}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:20},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=6}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:19},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=7}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:18},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=8}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:17},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=9}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:16},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=10}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:15},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=11}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:14},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=12}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:13},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=12}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:12},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=13}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:11},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=14}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:10},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=15}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:9},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=16}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:8},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=17}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:7},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=18}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:1},Count:1}]}
execute as @e[tag=chest_as,scores={intro_timer=19}] at @s run execute as @e[tag=chest_ai] at @s run data merge entity @s {NoAI:0}

execute as @e[tag=chest_as,scores={intro_timer=15,angry=1}] at @s run summon zombie ~ ~ ~ {Tags:[chest_ai],Silent:1,PersistenceRequired:1,ActiveEffects:[{Id:14b,Amplifier:1b,Duration:99999999,ShowParticles:0b}],IsBaby:1b,NoAI:1,Health:9999f,IsBaby:1b,Attributes:[{Name:generic.maxHealth,Base:9999},{Name:generic.movementSpeed,Base:0.18}]}


############################################################  Activation #####################################################

scoreboard players add @e[tag=chest_as] talk_cd 0
scoreboard players add @e[tag=chest_as] talk_count 0
scoreboard players remove @e[tag=chest_as,scores={talk_cd=1..}] talk_cd 1

execute as @e[scores={talk=1..}] at @s positioned ^ ^ ^2 run scoreboard players set @e[distance=..3,limit=1,sort=nearest,scores={talk_cd=0,talk_count=..3},tag=chest_as] talk_cd 40

execute as @e[scores={talk=1..}] at @s positioned ^ ^ ^2 run execute as @e[distance=..3,limit=1,sort=nearest,scores={talk_cd=0,talk_count=4..},tag=chest_as] at @s run playsound minecraft:entity.pillager.death master @a
execute as @e[scores={talk=1..}] at @s positioned ^ ^ ^2 run execute as @e[distance=..3,limit=1,sort=nearest,scores={talk_cd=0,talk_count=4..},tag=chest_as] at @s run playsound minecraft:block.chest.open master @a
execute as @e[scores={talk=1..}] at @s positioned ^ ^ ^2 run execute as @e[distance=..3,limit=1,sort=nearest,scores={talk_cd=0,talk_count=4..},tag=chest_as] at @s run execute as @e[tag=chest_villager,limit=1,sort=nearest] at @s run data merge entity @s {DeathTime:19,Health:0}

execute as @e[scores={talk=1..}] at @s positioned ^ ^ ^2 run scoreboard players set @e[distance=..3,limit=1,sort=nearest,scores={talk_cd=0,talk_count=4..},tag=chest_as] angry 1
execute as @e[scores={talk=1..}] at @s positioned ^ ^ ^2 run scoreboard players set @e[distance=..3,limit=1,sort=nearest,scores={talk_cd=0,talk_count=4..},tag=chest_as] intro_timer 1
execute as @e[scores={talk_cd=40}] at @s run summon armor_stand ~ ~0.7 ~ {Tags:["ex"],NoGravity:1,Marker:1,Invisible:1,CustomNameVisible:1b,CustomName:'{"text":"!","color":"red","bold":false,"italic":false}',DisabledSlots:4144959}
execute as @e[scores={talk_cd=40}] at @s run playsound minecraft:block.chest.locked master @a
execute as @e[scores={talk_cd=40}] at @s run scoreboard players add @s talk_count 1


scoreboard players add @e[tag=ex] ex_timer 1
execute as @e[tag=ex,scores={ex_timer=..3}] at @s run tp @s ~ ~0.15 ~
execute as @e[tag=ex,scores={ex_timer=4..6}] at @s run tp @s ~ ~0.12 ~
execute as @e[tag=ex,scores={ex_timer=7..9}] at @s run tp @s ~ ~0.09 ~
execute as @e[tag=ex,scores={ex_timer=10..12}] at @s run tp @s ~ ~0.06 ~
execute as @e[tag=ex,scores={ex_timer=13..16}] at @s run tp @s ~ ~0.03 ~
kill @e[tag=ex,scores={ex_timer=17..}]


execute as @e[type=item,nbt={Item:{id:"minecraft:book",Count:64b},OnGround:1b}] at @s run tag @e[tag=chest_as,scores={intro_timer=0},distance=..1] add ride_init

execute as @e[tag=ride_init] at @s run playsound minecraft:entity.player.levelup master @a
execute as @e[tag=ride_init] at @s run particle enchant ~ ~0.5 ~ 0.4 0.4 0.4 0.1 20 force
execute as @e[tag=ride_init] at @s run kill @e[type=item,nbt={Item:{id:"minecraft:book",Count:64b},OnGround:1b},distance=..1,limit=1,sort=nearest]
scoreboard players add @e[tag=chest_as_old] switch_timer 0
scoreboard players set @e[tag=ride_init,scores={switch_timer=0}] switch_timer 1
scoreboard players add @e[tag=chest_as_old,scores={switch_timer=1..}] switch_timer 1
tag @e[tag=ride_init] remove ride_init

execute as @e[tag=chest_as,scores={switch_timer=2}] at @s run execute as @e[tag=chest_villager,limit=1,sort=nearest] at @s run data merge entity @s {DeathTime:19,Health:0}
execute as @e[tag=chest_as,scores={switch_timer=2}] at @s run summon armor_stand ~ ~-3 ~ {Invisible:1,DisabledSlots:4144959,Tags:["chest_as","chest_as_new"],Marker:1b,Passengers:[{id:"minecraft:pig",Health:9999f,Attributes:[{Name:generic.maxHealth,Base:9999}],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:99999999,ShowParticles:0b}],Silent:1b,Invulnerable:1b,DeathLootTable:"",Tame:1b,NoAI:1,Saddle:1b,Tags:["chest_seat","invis"]}]}
execute as @e[tag=chest_as,scores={switch_timer=2}] at @s run summon armor_stand ~ ~ ~ {Tags:["chest_motion"],Marker:0b,Invisible:1,DisabledSlots:4144959}
execute as @e[tag=chest_as,scores={switch_timer=2}] at @s run scoreboard players set @e[tag=chest_as_new] angry 0
execute as @e[tag=chest_as,scores={switch_timer=2}] at @s run execute as @e[tag=chest_as_new] at @s run tp @s ~ ~3 ~
execute as @e[tag=chest_as,scores={switch_timer=8}] at @s run execute as @e[tag=chest_as_new,limit=1,sort=nearest] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"diamond_pickaxe",Count:1b,tag:{Unbreakable:1,Damage:23}}]}
execute as @e[tag=chest_as,scores={switch_timer=7}] at @s run scoreboard players set @e[tag=chest_as_new] intro_timer 1

kill @e[tag=chest_as_old,scores={switch_timer=8}]


############################################################ Friendly chest #####################################################

effect give @e[tag=chest_seat] regeneration 99 200 true
effect give @e[tag=chest_seat] resistance 99 200 true
execute as @e[tag=chest_motion] at @s run tp @e[tag=chest_as,limit=1,sort=nearest] @s

execute as @a[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}}}] at @s run tp @e[type=item,distance=..10] @s

execute as @a[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}}}] at @s run execute as @e[tag=chest_motion,limit=1,sort=nearest] run execute store result entity @s Rotation[0] float 1 run data get entity @p[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}}}] Rotation[0] 1
execute as @a[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}}}] at @s run execute as @e[tag=chest_as,limit=1,sort=nearest] run execute store result entity @s Rotation[0] float 1 run data get entity @p[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}}}] Rotation[0] 1
execute as @a[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}}}] at @s run execute as @e[tag=chest_seat,limit=1,sort=nearest] run execute store result entity @s Rotation[0] float 1 run data get entity @p[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}}}] Rotation[0] 1

scoreboard players set @e[tag=chest_motion] walk_block 0
execute as @e[tag=chest_motion] at @s if block ^ ^ ^0.5 #walking_chest:passable run scoreboard players set @s walk_block 1

execute as @e[tag=chest_motion,scores={walk_block=0}] at @s if block ^ ^1.0 ^0.5 #walking_chest:passable run scoreboard players set @s walk_block 2

execute as @e[tag=chest_as,scores={bite_timer2=38..}] at @s run scoreboard players set @e[tag=chest_motion,limit=1,sort=nearest,distance=..4] walk_block 0

execute as @a[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}},SelectedItemSlot:0}] at @s run execute as @e[tag=chest_motion,limit=1,sort=nearest] at @s run execute as @s[tag=chest_motion,scores={walk_block=1}] at @s run function walking_chest:walk
execute as @a[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}},SelectedItemSlot:0}] at @s run execute as @e[tag=chest_motion,limit=1,sort=nearest] at @s run execute as @s[tag=chest_motion,scores={walk_block=2}] at @s run function walking_chest:walk_up


scoreboard players add @e[tag=chest_as] bite_timer2 0
scoreboard players remove @e[tag=chest_as,scores={bite_timer2=1..,angry=0}] bite_timer2 1
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=47}] at @s run playsound minecraft:entity.evoker_fangs.attack master @a
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=46}] at @s run execute as @e[tag=chest_ai,limit=1,sort=nearest,distance=..2] run data merge entity @s {NoAI:1}
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=44}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:25},Count:1}]}
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=42}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:26},Count:1}]}
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=40}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:25},Count:1}]}
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=38}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}]}
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=38}] at @s run execute as @e[tag=chest_ai,limit=1,sort=nearest,distance=..2] run data merge entity @s {NoAI:0}

execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=42}] at @s run effect give @e[distance=..3,scores={ET=1}] instant_damage 2 2 true
execute as @e[tag=chest_as,scores={angry=0,intro_timer=40..,bite_timer2=42}] at @s run effect give @e[distance=..3,scores={ET=2}] instant_health 2 2 true



tag @e[tag=chest_as,scores={angry=0}] remove can_bite2
execute as @a at @s run execute as @e[scores={ET=1..2},distance=..4] at @s run tag @e[tag=chest_as,scores={angry=0},distance=..1.5] add can_bite2

scoreboard players set @e[tag=can_bite2,scores={angry=0,bite_timer2=0}] bite_timer2 50

execute as @e[tag=chest_as,scores={angry=0}] at @s if block ~ ~ ~ fire run execute as @a[distance=..3] at @s run tp @s ~ ~ ~
execute as @e[tag=chest_as,scores={angry=0}] at @s if block ~ ~ ~ fire run tag @s add kill


############################################################ Walking Animation #####################################################

scoreboard players add @e[tag=chest_as] angry 0

scoreboard players add @e[tag=chest_as] walk_timer 1
scoreboard players set @e[tag=chest_as,scores={walk_timer=16..}] walk_timer 0

scoreboard players set @e[tag=chest_as,scores={angry=1..}] chest_is_walking 1
execute as @e[tag=chest_ai,nbt={Motion:[0.0,0.0,0.0]}] at @s run scoreboard players set @e[tag=chest_as,distance=..2,limit=1,sort=nearest,scores={angry=1..}] chest_is_walking 0

scoreboard players set @e[tag=chest_as,scores={angry=0}] chest_is_walking 0
execute as @a[nbt={RootVehicle:{Entity:{Tags:["chest_as"]}},SelectedItemSlot:0}] at @s run scoreboard players set @e[tag=chest_as,distance=..2,limit=1,sort=nearest,scores={angry=0}] chest_is_walking 1

execute as @e[tag=chest_as,scores={walk_timer=0,chest_is_walking=1,angry=0,intro_timer=40..,bite_timer2=..38}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:1},Count:1}]}
execute as @e[tag=chest_as,scores={walk_timer=3,chest_is_walking=1,angry=0,intro_timer=40..,bite_timer2=..38}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1}]}
execute as @e[tag=chest_as,scores={walk_timer=8,chest_is_walking=1,angry=0,intro_timer=40..,bite_timer2=..38}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:1},Count:1}]}
execute as @e[tag=chest_as,scores={walk_timer=11,chest_is_walking=1,angry=0,intro_timer=40..,bite_timer2=..38}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:3},Count:1}]}
execute as @e[tag=chest_as,scores={chest_is_walking=0,angry=0,intro_timer=40..,bite_timer2=..38}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:1},Count:1}]}

execute as @e[tag=chest_as,scores={walk_timer=0,chest_is_walking=1,angry=1,intro_timer=40..,bite_timer=..88}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}]}
execute as @e[tag=chest_as,scores={walk_timer=3,chest_is_walking=1,angry=1,intro_timer=40..,bite_timer=..88}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:5},Count:1}]}
execute as @e[tag=chest_as,scores={walk_timer=8,chest_is_walking=1,angry=1,intro_timer=40..,bite_timer=..88}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}]}
execute as @e[tag=chest_as,scores={walk_timer=11,chest_is_walking=1,angry=1,intro_timer=40..,bite_timer=..88}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:6},Count:1}]}
execute as @e[tag=chest_as,scores={chest_is_walking=0,angry=1,intro_timer=40..,bite_timer=..88}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}]}


############################################################ Death #####################################################

execute as @e[tag=chest_as,tag=kill] at @s run kill @e[tag=chest_motion,limit=1,sort=nearest,distance=..1]
execute as @e[tag=chest_as,tag=kill] at @s run execute as @e[tag=chest_seat,limit=1,sort=nearest,distance=..2] at @s run data merge entity @s {DeathTime:19,Health:0}
execute as @e[tag=chest_as,tag=kill] at @s run execute as @e[tag=chest_ai,limit=1,sort=nearest,distance=..2] at @s run data merge entity @s {DeathTime:19,Health:0}
execute as @e[tag=chest_as,tag=kill] at @s run execute as @e[tag=chest_villager,limit=1,sort=nearest,distance=..2] at @s run data merge entity @s {DeathTime:19,Health:0}
execute as @e[tag=chest_as,tag=kill] at @s run playsound minecraft:entity.illusioner.death master @a
execute as @e[tag=chest_as,tag=kill] at @s run playsound minecraft:block.chest.close master @a
execute as @e[tag=chest_as,tag=kill] at @s run summon item ~-0.1 ~0.2 ~ {Item:{id:"minecraft:diamond",Count:3}}
execute as @e[tag=chest_as,tag=kill] at @s run summon item ~ ~ ~0.05 {Item:{id:"minecraft:chest",Count:1}}
kill @e[tag=chest_as,tag=kill]

############################################################ Angry Chest #####################################################


execute as @e[tag=chest_ai] at @s run tp @e[tag=chest_as,limit=1,sort=nearest] @s
effect give @e[tag=chest_ai] resistance 99 99 true
effect give @e[tag=invis] invisibility 9 9 true
effect give @e[tag=chest_ai] invisibility 9 9 true
execute as @e[tag=chest_ai] at @s run data merge entity @s {Fire:-10s}

scoreboard players add @e[tag=chest_as] chest_health 0
execute as @e[tag=chest_ai,nbt={HurtTime:9s}] at @s run scoreboard players add @e[tag=chest_as,limit=1,sort=nearest,distance=..1] chest_health 1
execute as @e[tag=chest_as,scores={chest_health=10..}] at @s run tag @s add kill


scoreboard players add @e[tag=chest_as] bite_timer 0
scoreboard players remove @e[tag=chest_as,scores={bite_timer=1..,angry=1..}] bite_timer 1
execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=97}] at @s run playsound minecraft:entity.evoker_fangs.attack master @a
execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=96}] at @s run execute as @e[tag=chest_ai,limit=1,sort=nearest,distance=..2] run data merge entity @s {NoAI:1}
execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=94}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:25},Count:1}]}
execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=92}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:26},Count:1}]}
execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=90}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:25},Count:1}]}
execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=88}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}]}
execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=88}] at @s run execute as @e[tag=chest_ai,limit=1,sort=nearest,distance=..2] run data merge entity @s {NoAI:0}

execute as @e[tag=chest_as,scores={angry=1,intro_timer=40..,bite_timer=92}] at @s run effect give @a[distance=..3] instant_damage 1 1 true


tag @e[tag=chest_as,scores={angry=1..}] remove can_bite
execute as @a at @s run tag @e[tag=chest_as,scores={angry=1..},distance=..2] add can_bite

scoreboard players set @e[tag=can_bite,scores={bite_timer=0}] bite_timer 100



################################################################################################################




tag @a remove give
scoreboard players set @a talk 0
scoreboard players set @a sneak 0
scoreboard players set @a jump 0
scoreboard players set @a rc 0
scoreboard players set @a pick_used 0
